app([],X,X).
app([X|Xs],Y,[X|Z]) :- app(Xs,Y,Z).

% del(X,Y,Z)
% Note that this is slightly different from 
% the version in slowsort.pl:
% It deletes ALL occurrences of X from Y:
del(_,[],[]).
del(X,[X|Xs],Y) :- del(X,Xs,Y).
del(X,[Y|Xs],[Y|Ys]) :- X =\= Y, del(X,Xs,Ys).


% reverse a list:
bad_rev([],[]).
bad_rev([X|Y],Z) :- bad_rev(Y,Y1), app(Y1,[X],Z).

% better version:
rev(List, Reversed) :-
	rev(List, [], Reversed).
rev([], Reversed, Reversed).
rev([Head|Tail], SoFar, Reversed) :-
	rev(Tail, [Head|SoFar], Reversed).

% inefficient version for checking whether a list is a palindrome:
palindrom([],[]).
palindrom([X],[X]).
palindrom(Z) :- app(app(X,Y,Z), rev(X,Y).
